


/*
  Unique constructeur de la classe abstraite (au sens du CRTP) CAllPolyformPiecesPositions.
  Celui-ci fait appel  la fonction virtuelle (au sens du CRTP) computeAllPiecesPositions,
  laquelle doit tre redfinie par drivation dans une classe fille de CAllPolyformPiecesPositions,
  afin de calculer toutes les positions possibles de toutes les pices d'un certain jeu dans une structure
  quelconque S. Il y a NB_PIECES (argument template) pices et leurs positions sont donnes relativement
   la bote englobante de S, c'est--dire le plus petit paralllpipde rectangle contenant S.
  
Argument :
    - type : soma::utils::general::CBitArray3D.
    - nom : boundingBox.
    - boundingBox est en fait un tableau de bits  3 dimensions qui contient une stucture  rsoudre S.
      Si un cube de S est le cube situ  la position (i,j,k) de boundingBox, alors boundingBox(i,j,k)==true,
      sinon boundingBox(i,j,k)==false. boundingBox est assign  au membre priv m_BoundingBox (rfrence constante).
*/
template
  <
  unsigned char NB_PIECES,
  typename DerivedT,
  typename BitArrayT,
  typename PositionsMatrixT
  >
CAllPolyformPiecesPositions<NB_PIECES,DerivedT,BitArrayT,PositionsMatrixT>::CAllPolyformPiecesPositions
                                                                                                      (
                                                                                                      const bit_array_t& boundingBox
                                                                                                      ) :
                                                                                                         m_BoundingBox
                                                                                                                     (
                                                                                                                     boundingBox
                                                                                                                     )

  {
  computeAllPiecesPositions();
  }
